=== debian/changelog ===
cgal (4.0.2-1build1) saucy; urgency=low

  * No change rebuild for Boost 1.53 transition.

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Fri, 26 Apr 2013 19:18:40 +0100

cgal (4.0.2-1) unstable; urgency=low

  * New upstream release.
  * Remove gcc-4.7 patch (fixed upstream).

 -- Joachim Reichel <reichel@debian.org>  Wed, 04 Jul 2012 19:45:28 +0200

cgal (4.0-4) unstable; urgency=low

  * Add Suggests: libeigen3-dev (>= 3.1.0~beta1-1), libmpfi-dev to
    libcgal-demo.

 -- Joachim Reichel <reichel@debian.org>  Tue, 12 Jun 2012 23:53:14 +0200

cgal (4.0-3) unstable; urgency=low

  * Change Build-Depends: debhelper (>= 8) to debhelper (>= 9), update
    debian/compat to get the default build flags for hardening. Inject
    CPPFLAGS into CFLAGS and CXXFLAGS, since CPPFLAGS is ignored by cmake.
  * Add lintian override to silence incorrect warnings about
    hardening-no-fortify-functions for some libraries (all libraries are
    built with the same flags).

 -- Joachim Reichel <reichel@debian.org>  Sun, 10 Jun 2012 15:36:27 +0200
